package cn.iocoder.yudao.module.pms.service.iotattachment;

import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.common.util.object.BeanUtils;
import cn.iocoder.yudao.module.pms.controller.admin.iotattachment.vo.IotAttachmentPageReqVO;
import cn.iocoder.yudao.module.pms.controller.admin.iotattachment.vo.IotAttachmentSaveReqVO;
import cn.iocoder.yudao.module.pms.dal.dataobject.iotattachment.IotAttachmentDO;
import cn.iocoder.yudao.module.pms.dal.mysql.iotattachment.IotAttachmentMapper;
import org.springframework.stereotype.Service;
import org.springframework.validation.annotation.Validated;

import javax.annotation.Resource;

import java.util.List;

import static cn.iocoder.yudao.framework.common.exception.util.ServiceExceptionUtil.exception;
import static cn.iocoder.yudao.module.pms.enums.ErrorCodeConstant.IOT_ATTACHMENT_NOT_EXISTS;

/**
 * 附件 Service 实现类
 *
 * @author 超级管理员
 */
@Service
@Validated
public class IotAttachmentServiceImpl implements IotAttachmentService {

    @Resource
    private IotAttachmentMapper iotAttachmentMapper;

    @Override
    public Long createIotAttachment(IotAttachmentSaveReqVO createReqVO) {
        // 插入
        IotAttachmentDO iotAttachment = BeanUtils.toBean(createReqVO, IotAttachmentDO.class);
        iotAttachmentMapper.insert(iotAttachment);
        // 返回
        return iotAttachment.getId();
    }

    @Override
    public void updateIotAttachment(IotAttachmentSaveReqVO updateReqVO) {
        // 校验存在
        validateIotAttachmentExists(updateReqVO.getId());
        // 更新
        IotAttachmentDO updateObj = BeanUtils.toBean(updateReqVO, IotAttachmentDO.class);
        iotAttachmentMapper.updateById(updateObj);
    }

    @Override
    public void deleteIotAttachment(Long id) {
        // 校验存在
        validateIotAttachmentExists(id);
        // 删除
        iotAttachmentMapper.deleteById(id);
    }

    private void validateIotAttachmentExists(Long id) {
        if (iotAttachmentMapper.selectById(id) == null) {
            throw exception(IOT_ATTACHMENT_NOT_EXISTS);
        }
    }

    @Override
    public IotAttachmentDO getIotAttachment(Long id) {
        return iotAttachmentMapper.selectById(id);
    }

    @Override
    public PageResult<IotAttachmentDO> getIotAttachmentPage(IotAttachmentPageReqVO pageReqVO) {
        return iotAttachmentMapper.selectPage(pageReqVO);
    }

    @Override
    public List<IotAttachmentDO> getIotAttachments(IotAttachmentPageReqVO pageReqVO) {
        return iotAttachmentMapper.attachments(pageReqVO);
    }

}